#définition du dossier de travail
setwd("C:/Users/Guillaume/Documents/bio-ingénieur/MA2/TFE/Dossier_TFE_Charles_G/Comparaison_revolution_eclaircies/Fichiers_sortie_CAT")

#packages
library(tidyverse)
library(ggpubr)
library(rstatix)
library(dplyr)
library(PairedData)
library(writexl)


#import des données et suppression des colonnes vides
E88 <- read.csv("88E_C_moy.csv", header = T, sep = ";", dec = ",",  fileEncoding="latin1")
SE88 <- read.csv("88SE_C_moy.csv", header = T, sep = ";", dec = ",",  fileEncoding="latin1")
E58 <- read.csv("58E_C_moy.csv", header = T, sep = ";", dec = ",",  fileEncoding="latin1")
SE58 <- read.csv("58SE_C_moy.csv", header = T, sep = ";", dec = ",",  fileEncoding="latin1")
E100 <- read.csv("100E_C_moy.csv", header = T, sep = ";", dec = ",",  fileEncoding="latin1")
SE100 <- read.csv("100SE_C_moy.csv", header = T, sep = ";", dec = ",",  fileEncoding="latin1")
E70 <- read.csv("70E_C_moy.csv", header = T, sep = ";", dec = ",",  fileEncoding="latin1")
SE70 <- read.csv("70SE_C_moy.csv", header = T, sep = ";", dec = ",",  fileEncoding="latin1")
E82 <- read.csv("82E_C_moy.csv", header = T, sep = ";", dec = ",",  fileEncoding="latin1")
SE82 <- read.csv("82SE_C_moy.csv", header = T, sep = ";", dec = ",",  fileEncoding="latin1")


E88$gf <- "E88"
SE88$gf <- "SE88"
E58$gf <- "E58"
SE58$gf <- "SE58"
E70$gf <- "E70"
SE70$gf <- "SE70"
E82$gf <- "E82"
SE82$gf <- "SE82"
E100$gf <- "E100"
SE100$gf <- "SE100"

tout <- rbind(E88,SE88,E58,SE58,E70,SE70,E82,SE82,E100,SE100)

#création de la colonne type et suppression des types inutiles pour le total
tout$type <- "NA"
for (i in 1:nrow(tout)){
  if (tout$Compart[i] == "Biomasse sou") {
    tout$type[i] <- "BS"
  } else if (tout$Compart[i] == "Biomasse aÚr") {
    tout$type[i] <- "BA"
  } else if (tout$Compart[i] == "MatiÞre orga") {
    tout$type[i] <- "MO"
  } else if (tout$Compart[i] == "En usage") {
    tout$type[i] <- "suppr"
  } else if (tout$Compart[i] == "Au site d'en") {
    tout$type[i] <- "suppr"
  } else if (tout$Compart[i] == "Emissions d'") {
    tout$type[i] <- "EM"
  } else if (tout$Compart[i] == "Substitution") {
    tout$type[i] <- "SU"
  } else if (tout$Compart[i] == "Site d'enfou") {
    tout$type[i] <- "suppr"
  } else if (tout$Compart[i] == "Combustion d") {
    tout$type[i] <- "suppr" 
  } else if (tout$Compart[i] == "Biomasse viv") {
    tout$type[i] <- "BV"
  } else if (tout$Compart[i] == "Tous les pro") {
    tout$type[i] <- "PB"
  } else if (tout$Compart[i] == "Flux net cum") {
    tout$type[i] <- "FN"
  }} 

tout <- subset(tout, type != "suppr" & type != "FN" & type != "EM" & type !="BS" & type != "BA") 


#éliminer les colonnes inutiles#
tout <- tout[,c(3:6)]

#éliminer les df inutiles
rm(E88,SE88,E58,SE58,E70,SE70,E82,SE82,E100,SE100)

#changer le nom des colonnes
names(tout) <- c ("MgC","real","gf","type")

#séparer pour les comparaisons
stocks <- subset(tout,type != "SU")
flux <- subset(tout, type == "SU")




#### PREPARATION DES DF

### E100 - E82
E100s <- subset(stocks,gf =="E82" | gf == "E100")
E100f <- subset(flux,gf == "E82" | gf == "E100")

#stocks
dE100s = E100s %>% group_by(real,type) %>%
  summarise(MgC = diff(MgC),
            .groups = 'drop')
dE100sgroup = dE100s %>% group_by(real) %>%
  summarise(MgC = sum(MgC),
            .groups = 'drop')
dE100sgroup$type <- "st"
dE100s <- rbind(dE100s,dE100sgroup)

#flux
dE100f = E100f %>% group_by(real,type) %>%
  summarise(MgC = diff(MgC),
            .groups = 'drop')

#PARENTHESE : vérfier qu'on a bien des données appariées

BVE82 <- subset(E100s,  gf == "E82" & type == "BV", MgC,
              drop = TRUE)
BVE100 <- subset(E100s, gf == "E100" & type == "BV", MgC,
              drop = TRUE)
pd <- paired(BVE82, BVE100)
plot(pd, type = "profile") + theme_bw()

#fin de la parenthèse



### E88 - E82
E88s <- subset(stocks,gf =="E82" | gf == "E88")
E88f <- subset(flux,gf == "E82" | gf == "E88")

#stocks
dE88s = E88s %>% group_by(real,type) %>%
  summarise(MgC = -diff(MgC),
            .groups = 'drop')
dE88sgroup = dE88s %>% group_by(real) %>%
  summarise(MgC = sum(MgC),
            .groups = 'drop')
dE88sgroup$type <- "st"
dE88s <- rbind(dE88s,dE88sgroup)

#flux
dE88f = E88f %>% group_by(real,type) %>%
  summarise(MgC = -diff(MgC),
            .groups = 'drop')



### E70 - E82
E70s <- subset(stocks,gf =="E82" | gf == "E70")
E70f <- subset(flux,gf == "E82" | gf == "E70")

#stocks
dE70s = E70s %>% group_by(real,type) %>%
  summarise(MgC = -diff(MgC),
            .groups = 'drop')
dE70sgroup = dE70s %>% group_by(real) %>%
  summarise(MgC = sum(MgC),
            .groups = 'drop')
dE70sgroup$type <- "st"
dE70s <- rbind(dE70s,dE70sgroup)

#flux
dE70f = E70f %>% group_by(real,type) %>%
  summarise(MgC = -diff(MgC),
            .groups = 'drop')


### E58 - E82
E58s <- subset(stocks,gf =="E82" | gf == "E58")
E58f <- subset(flux,gf == "E82" | gf == "E58")

#stocks
dE58s = E58s %>% group_by(real,type) %>%
  summarise(MgC = -diff(MgC),
            .groups = 'drop')
dE58sgroup = dE58s %>% group_by(real) %>%
  summarise(MgC = sum(MgC),
            .groups = 'drop')
dE58sgroup$type <- "st"
dE58s <- rbind(dE58s,dE58sgroup)

#flux
dE58f = E58f %>% group_by(real,type) %>%
  summarise(MgC = -diff(MgC),
            .groups = 'drop')



### SE100 - E82
SE100s <- subset(stocks,gf =="E82" | gf == "SE100")
SE100f <- subset(flux,gf == "E82" | gf == "SE100")

#stocks
dSE100s = SE100s %>% group_by(real,type) %>%
  summarise(MgC = diff(MgC),
            .groups = 'drop')
dSE100sgroup = dSE100s %>% group_by(real) %>%
  summarise(MgC = sum(MgC),
            .groups = 'drop')
dSE100sgroup$type <- "st"
dSE100s <- rbind(dSE100s,dSE100sgroup)

#flux
dSE100f = SE100f %>% group_by(real,type) %>%
  summarise(MgC = diff(MgC),
            .groups = 'drop')



### SE88 - E82
SE88s <- subset(stocks,gf =="E82" | gf == "SE88")
SE88f <- subset(flux,gf == "E82" | gf == "SE88")

#stocks
dSE88s = SE88s %>% group_by(real,type) %>%
  summarise(MgC = -diff(MgC),
            .groups = 'drop')
dSE88sgroup = dSE88s %>% group_by(real) %>%
  summarise(MgC = sum(MgC),
            .groups = 'drop')
dSE88sgroup$type <- "st"
dSE88s <- rbind(dSE88s,dSE88sgroup)

#flux
dSE88f = SE88f %>% group_by(real,type) %>%
  summarise(MgC = -diff(MgC),
            .groups = 'drop')



### SE88 - E82
SE82s <- subset(stocks,gf =="E82" | gf == "SE82")
SE82f <- subset(flux,gf == "E82" | gf == "SE82")

#stocks
dSE82s = SE82s %>% group_by(real,type) %>%
  summarise(MgC = diff(MgC),
            .groups = 'drop')
dSE82sgroup = dSE82s %>% group_by(real) %>%
  summarise(MgC = sum(MgC),
            .groups = 'drop')
dSE82sgroup$type <- "st"
dSE82s <- rbind(dSE82s,dSE82sgroup)

#flux
dSE82f = SE82f %>% group_by(real,type) %>%
  summarise(MgC = diff(MgC),
            .groups = 'drop')



### SE70 - E82
SE70s <- subset(stocks,gf =="E82" | gf == "SE70")
SE70f <- subset(flux,gf == "E82" | gf == "SE70")

#stocks
dSE70s = SE70s %>% group_by(real,type) %>%
  summarise(MgC = -diff(MgC),
            .groups = 'drop')
dSE70sgroup = dSE70s %>% group_by(real) %>%
  summarise(MgC = sum(MgC),
            .groups = 'drop')
dSE70sgroup$type <- "st"
dSE70s <- rbind(dSE70s,dSE70sgroup)

#flux
dSE70f = SE70f %>% group_by(real,type) %>%
  summarise(MgC = -diff(MgC),
            .groups = 'drop')



### SE58 - E82
SE58s <- subset(stocks,gf =="E82" | gf == "SE58")
SE58f <- subset(flux,gf == "E82" | gf == "SE58")

#stocks
dSE58s = SE58s %>% group_by(real,type) %>%
  summarise(MgC = -diff(MgC),
            .groups = 'drop')
dSE58sgroup = dSE58s %>% group_by(real) %>%
  summarise(MgC = sum(MgC),
            .groups = 'drop')
dSE58sgroup$type <- "st"
dSE58s <- rbind(dSE58s,dSE58sgroup)

#flux
dSE58f = SE58f %>% group_by(real,type) %>%
  summarise(MgC = -diff(MgC),
            .groups = 'drop')

### E82 - E82
E82s <- subset(stocks,gf =="E82")
E82f <- subset(flux,gf == "E82")
E82sbis <- subset(stocks, gf == "E82")
E82fbis <- subset(flux, gf == "E82")
E82s <- rbind(E82s,E82sbis)
E82f <- rbind(E82f,E82fbis)

#stocks
dE82s = E82s %>% group_by(real,type) %>%
  summarise(MgC = diff(MgC),
            .groups = 'drop')

dE82sgroup = dE82s %>% group_by(real) %>%
  summarise(MgC = sum(MgC),
            .groups = 'drop')
dE82sgroup$type <- "st"
dE82s <- rbind(dE82s,dE82sgroup)

#flux
dE82f = E82f %>% group_by(real,type) %>%
  summarise(MgC = -diff(MgC),
            .groups = 'drop')

dE100s$gf <- "5"
dE88s$gf <- "4"
dE82s$gf <- "3"
dE70s$gf <- "2"
dE58s$gf <- "1"
dSE100s$gf <- "55"
dSE88s$gf <- "44"
dSE82s$gf <- "33"
dSE70s$gf <- "22"
dSE58s$gf <- "11"
d <- rbind(dE100s,dE88s,dE82s,dE70s,dE58s,dSE100s,dSE88s,dSE82s,dSE70s,dSE58s)

dE100f$gf <- "5"
dE88f$gf <- "4"
dE82f$gf <- "3"
dE70f$gf <- "2"
dE58f$gf <- "1"
dSE100f$gf <- "55"
dSE88f$gf <- "44"
dSE82f$gf <- "33"
dSE70f$gf <- "22"
dSE58f$gf <- "11"
f <- rbind(dE100f,dE88f,dE82f,dE70f,dE58f,dSE100f,dSE88f,dSE82f,dSE70f,dSE58f)

#prise des 95%
f95 = arrange(f,gf,MgC)
f95$num <- ave(f95$MgC,f95$gf,FUN = seq_along)
f95 <- subset(f95, f95$num > 12 & f95$num < 489)

d95 = arrange(d,gf,type,MgC)
d95$num <- ave(d95$MgC,d95$gf,d95$type,FUN = seq_along)
d95 <- subset(d95, d95$num > 12 & d95$num < 489)

#présentation graphique

par(mfrow = c(2,2))

dBV <- subset(d,type =="BV")
dBV95 <- subset(d95,type == "BV")
mean_dBV <- tapply(dBV$MgC,dBV$gf,mean)
graphique = barplot(mean_dBV,main = "Biomasse vivante", ylab ="Stock de carbone (différence) [tC/ha]", names=c("E58","SE58","E70","SE70","E82","SE82","E88","SE88","E100", "SE100"), cex.lab=1,cex.names=0.7, col=c("darkgrey","white"),space=1, ylim = c(-60,150))
min <- tapply(dBV95$MgC, dBV95$gf, min)
max <- tapply(dBV95$MgC, dBV95$gf, max)
arrows(graphique,min,graphique,max, lwd=2, angle=90,length=0.1,code=3)
abline(h = 0, col = "black")

dMO <- subset(d,type =="MO")
dMO95 <- subset(d95,type =="MO")
mean_dMO <- tapply(dMO$MgC,dMO$gf,mean)
graphique = barplot(mean_dMO,main = "Matière organique morte", ylab ="Stock de carbone (différence) [tC/ha]", names=c("E58","SE58","E70","SE70","E82","SE82","E88","SE88","E100", "SE100"), cex.lab=1,cex.names=0.7, col=c("darkgrey","white"),space=1, ylim = c(-60,150))
min <- tapply(dMO95$MgC, dMO95$gf, min)
max <- tapply(dMO95$MgC, dMO95$gf, max)
arrows(graphique,min,graphique,max, lwd=2, angle=90,length=0.1,code=3)
abline(h = 0, col = "black")

dPB <- subset(d,type =="PB")
dPB95 <- subset(d95,type =="PB")
mean_dPB <- tapply(dPB$MgC,dPB$gf,mean)
graphique = barplot(mean_dPB,main = "Produits bois", ylab ="Stock de carbone (différence) [tC/ha]", names=c("E58","SE58","E70","SE70","E82","SE82","E88","SE88","E100", "SE100"), cex.lab=1,cex.names=0.7, col=c("darkgrey","white"),space=1, ylim = c(-60,150))
min <- tapply(dPB95$MgC, dPB95$gf, min)
max <- tapply(dPB95$MgC, dPB95$gf, max)
arrows(graphique,min,graphique,max, lwd=2, angle=90,length=0.1,code=3)
abline(h = 0, col = "black")

dst <- subset(d,type =="st")
dst95 <- subset(d95,type =="st")
mean_dst <- tapply(dst$MgC,dst$gf,mean)
graphique = barplot(mean_dst,main = "Ensemble des réservoirs", ylab ="Stock de carbone (différence) [tC/ha]", names=c("E58","SE58","E70","SE70","E82","SE82","E88","SE88","E100", "SE100"), cex.lab=1,cex.names=0.7, col=c("darkgrey","white"),space=1, ylim = c(-150,400))
min <- tapply(dst95$MgC, dst95$gf, min)
max <- tapply(dst95$MgC, dst95$gf, max)
arrows(graphique,min,graphique,max, lwd=2, angle=90,length=0.1,code=3)
abline(h = 0, col = "black")

par(mfrow = c(1,1))
mean_df <- tapply(f$MgC,f$gf,mean)
graphique = barplot(mean_df, ylab ="Substitution (différence) [tC/(ha.an)]", names=c("E58","SE58","E70","SE70","E82","SE82","E88","SE88","E100", "SE100"), cex.lab=0.7,cex.names=0.7, col=c("grey","white"),space=1, ylim = c(-1.5,0.5))
min <- tapply(f95$MgC, f95$gf, min)
max <- tapply(f95$MgC, f95$gf, max)
arrows(graphique,min,graphique,max, lwd=2, angle=90,length=0.1,code=3)
abline(h = 0, col = "black")

#### TABLEAUX 

toutgroupm = tout %>% group_by(gf,type) %>%
  summarise(MgC = mean(MgC),
            .groups = 'drop')
write_xlsx(toutgroupm, "C:/Users/Guillaume/Documents/bio-ingénieur/MA2/TFE/Dossier_TFE_Charles_G/Comparaison_revolution_eclaircies/Fichiers_sortie_R/moyennes.xlsx")




##billons

#import des données et suppression des colonnes vides
E88 <- read.csv("88E_billons.csv", header = T, sep = ";", dec = ",",  fileEncoding="latin1")
SE88 <- read.csv("88SE_billons.csv", header = T, sep = ";", dec = ",",  fileEncoding="latin1")
E58 <- read.csv("58E_billons.csv", header = T, sep = ";", dec = ",",  fileEncoding="latin1")
SE58 <- read.csv("58SE_billons.csv", header = T, sep = ";", dec = ",",  fileEncoding="latin1")
E100 <- read.csv("100E_billons.csv", header = T, sep = ";", dec = ",",  fileEncoding="latin1")
SE100 <- read.csv("100SE_billons.csv", header = T, sep = ";", dec = ",",  fileEncoding="latin1")
E70 <- read.csv("70E_billons.csv", header = T, sep = ";", dec = ",",  fileEncoding="latin1")
SE70 <- read.csv("70SE_billons.csv", header = T, sep = ";", dec = ",",  fileEncoding="latin1")
E82 <- read.csv("82E_billons.csv", header = T, sep = ";", dec = ",",  fileEncoding="latin1")
SE82 <- read.csv("82SE_billons.csv", header = T, sep = ";", dec = ",",  fileEncoding="latin1")

E88$gf <- "E88"
SE88$gf <- "SE88"
E58$gf <- "E58"
SE58$gf <- "SE58"
E70$gf <- "E70"
SE70$gf <- "SE70"
E82$gf <- "E82"
SE82$gf <- "SE82"
E100$gf <- "E100"
SE100$gf <- "SE100"

tout <- rbind(E88,SE88,E58,SE58,E70,SE70,E82,SE82,E100,SE100)
tout <- subset(tout,Species =="Picea abies")

toutmV = tout %>% group_by(gf,LogCategor) %>%
  summarise(V = mean(Volume_m3h),
            .groups = 'drop')

write_xlsx(toutmV, "C:/Users/Guillaume/Documents/bio-ingénieur/MA2/TFE/Dossier_TFE_Charles_G/Comparaison_revolution_eclaircies/Fichiers_sortie_R/billons.xlsx")




#### PTPBC
ptbE58 <- read.csv("58E_PTPBC.csv", header = T, sep = ";", dec = ",",  fileEncoding="latin1")
ptbE70 <- read.csv("70E_PTPBC.csv", header = T, sep = ";", dec = ",",  fileEncoding="latin1")
ptbE82 <- read.csv("82E_PTPBC.csv", header = T, sep = ";", dec = ",",  fileEncoding="latin1")
ptbE88 <- read.csv("88E_PTPBC.csv", header = T, sep = ";", dec = ",",  fileEncoding="latin1")
ptbE100 <- read.csv("100E_PTPBC.csv", header = T, sep = ";", dec = ",",  fileEncoding="latin1")
ptbSE58 <- read.csv("58SE_PTPBC.csv", header = T, sep = ";", dec = ",",  fileEncoding="latin1")
ptbSE70 <- read.csv("70SE_PTPBC.csv", header = T, sep = ";", dec = ",",  fileEncoding="latin1")
ptbSE82 <- read.csv("82SE_PTPBC.csv", header = T, sep = ";", dec = ",",  fileEncoding="latin1")
ptbSE88 <- read.csv("88SE_PTPBC.csv", header = T, sep = ";", dec = ",",  fileEncoding="latin1")
ptbSE100 <- read.csv("100SE_PTPBC.csv", header = T, sep = ";", dec = ",",  fileEncoding="latin1")

ptbE58 <- subset(ptbE58,Species =="Picea abies")
moy58 = ptbE58 %>% group_by(Type,Class) %>%
  summarise(V = mean(Volume_m3h),
            .groups = 'drop')
moy58$gf <- "E58"

ptbE70 <- subset(ptbE70,Species =="Picea abies")
moy70 = ptbE70 %>% group_by(Type,Class) %>%
  summarise(V = mean(Volume_m3h),
            .groups = 'drop')
moy70$gf <- "E70"

ptbE82 <- subset(ptbE82,Species =="Picea abies")
moy82 = ptbE82 %>% group_by(Type,Class) %>%
  summarise(V = mean(Volume_m3h),
            .groups = 'drop')
moy82$gf <- "E82"

ptbE88 <- subset(ptbE88,Species =="Picea abies")
moy88 = ptbE88 %>% group_by(Type,Class) %>%
  summarise(V = mean(Volume_m3h),
            .groups = 'drop')
moy88$gf <- "E88"

ptbE100 <- subset(ptbE100,Species =="Picea abies")
moy100 = ptbE100 %>% group_by(Type,Class) %>%
  summarise(V = mean(Volume_m3h),
            .groups = 'drop')
moy100$gf <- "E100"


ptbSE58 <- subset(ptbSE58,Species =="Picea abies")
moyS58 = ptbSE58 %>% group_by(Type,Class) %>%
  summarise(V = mean(Volume_m3h),
            .groups = 'drop')
moyS58$gf <- "SE58"

ptbSE70 <- subset(ptbSE70,Species =="Picea abies")
moyS70 = ptbSE70 %>% group_by(Type,Class) %>%
  summarise(V = mean(Volume_m3h),
            .groups = 'drop')
moyS70$gf <- "SE70"

ptbSE82 <- subset(ptbSE82,Species =="Picea abies")
moyS82 = ptbSE82 %>% group_by(Type,Class) %>%
  summarise(V = mean(Volume_m3h),
            .groups = 'drop')
moyS82$gf <- "SE82"

ptbSE88 <- subset(ptbSE88,Species =="Picea abies")
moyS88 = ptbSE88 %>% group_by(Type,Class) %>%
  summarise(V = mean(Volume_m3h),
            .groups = 'drop')
moyS88$gf <- "SE88"

ptbSE100 <- subset(ptbSE100,Species =="Picea abies")
moyS100 = ptbSE100 %>% group_by(Type,Class) %>%
  summarise(V = mean(Volume_m3h),
            .groups = 'drop')
moyS100$gf <- "SE100"

tout <- rbind(moy58,moy70,moy82,moy88,moy100,moyS58,moyS70,moyS82,moyS88,moyS100)

write_xlsx(tout, "C:/Users/Guillaume/Documents/bio-ingénieur/MA2/TFE/Dossier_TFE_Charles_G/Comparaison_revolution_eclaircies/Fichiers_sortie_R/produits_bois.xlsx")


